﻿using System;
using System.Linq;
using System.Windows.Forms;

using HidLibrary;

namespace USB
{
    public partial class Form1 : Form
    {

        private HidDevice USB_Device;
        //public delegate void ReadHandlerDelegate(HidReport report);

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            USB_Device = HidDevices.Enumerate(1155, 22352).FirstOrDefault();

            try
            {
                USB_Device.OpenDevice();
            }
            catch
            {
                Output.Text = "Device Not Found!";
                return;
            }

            var USB_TX_Report = USB_Device.CreateReport();
            USB_TX_Report.ReportId = 1;
            USB_TX_Report.Data[0] = 0x0A;
            USB_Device.WriteReport(USB_TX_Report,100);

            USB_Device.ReadReport(ReadHandler,100);

            //USB_Device.MonitorDeviceEvents = true;
            //USB_Device.ReadReport(ReadProcess);

        }

        private void button2_Click(object sender, EventArgs e)
        {

            USB_Device = HidDevices.Enumerate(1155, 22352).FirstOrDefault();

            try
            {
                USB_Device.OpenDevice();
            }
            catch
            {
                Output.Text = "Device Not Found!";
                return;
            }

            var USB_TX_Report = USB_Device.CreateReport();
            USB_TX_Report.ReportId = 1;
            USB_TX_Report.Data[0] = 0x0B;
            USB_Device.WriteReport(USB_TX_Report, 100);

            USB_Device.ReadReport(ReadHandler, 100);

        }

        /*
        private void ReadProcess(HidReport report)
        {
            BeginInvoke(new ReadHandlerDelegate(ReadHandler), new object[] { report });
        }
        */
        private void ReadHandler(HidReport report)
        {

            this.Invoke((MethodInvoker)delegate()
            {
                Output.Text = report.Data.ToUTF8String();
            });

            //Output.Clear();
            //Output.AppendText(String.Join(" ", report.Data.Select(d => d.ToString("X2"))));

            //USB_Device.ReadReport(ReadProcess);
        }

    }
}
